#include "libnazgul.h"

/* prototypes des f#define MSGSPACE_DEFAULT_MODE 0600
#define MSGSPACE_ID_LEN 32

onctions annexes  ne pas exporter */
int msgSpaceIdIntern(msgSpaceId dest,const msgSpaceId src );
int msgPoolDataIdIntern(msgSpaceId dest,const msgSpaceId src );

/*
 * spaceId : identifiant externe de l'espace de msg
 * queueNb : nombre de files de messages
 * poolNb : nombre de pool de buffers
 * queueNbCar : tableau de caracteristiques des different pool
 */

msgSpace * msgSpaceCreate(
	msgSpaceId spaceId, 
	int queueNb, 
	int poolNb, 
	msgPool * queueNbCar ){
  msgSpaceId nzgId;
  /* msgSpaceList mSList;  */
  int mSFd; // shm file descriptor
  int mSPoolDataFd; // shm file descriptor
  int i;
  static int mSIdNum=-1;
  msgSpace * mSAddr;

  msgSpacePoolId poolDataId;
  msgPoolData * mSPoolDataAddr; 

  fprintf(stderr,"Creating msgSpace with id : %s\n",spaceId);

  mSIdNum++;
  mSAddr=NULL;
  /** recuperation de la liste des msgSpace **/
  /* (creation si elle n'existe pas */

  /** on cree le nouvel element **/
  printf("PAGESIZE : %d\n",(int)PAGESIZE);
  if (msgSpaceIdIntern(nzgId,spaceId) < 0){
	return NULL;
  }
  printf("Id interne : %s\n",nzgId);
  mSFd=shm_open(
	  nzgId,
	  O_RDWR|O_CREAT|O_EXCL|O_TRUNC,
	  MSGSPACE_DEFAULT_MODE
	  );
  if (mSFd == -1 ) {
	fprintf( stderr, "msgSpace %s creation failed: %s\n",
		(char*)nzgId,
		strerror( errno ) );
	return NULL;
  }

  /* on redimentionne l'element */
  if (ftruncate(mSFd, sizeof(* mSAddr)) == -1){
	fprintf( stderr, "msgSpace resizing failed: %s\n",
		strerror( errno ) );
	return NULL;
  }

  /* Map the memory object */
  mSAddr = mmap( 0, sizeof( *mSAddr ),
	  PROT_READ | PROT_WRITE,
	  MAP_SHARED, mSFd, 0 );
  if( mSAddr == MAP_FAILED ) {
	fprintf( stderr, "mmap failed: %s\n",
		strerror( errno ) );
	return NULL;
  }

  printf( "msgSpace map addr is 0x%08x\n", (int)mSAddr );

  /* on ferme le descripteur du fichier */
  close(mSFd);

  /* on remplit la structure */
  strncpy(mSAddr->id,nzgId,MSGSPACE_ID_LEN);
  mSAddr->poolNb=poolNb;
  mSAddr->queueNb=queueNb;
  mSAddr->pid=getpid();

  /*  creation du poolData */
  msgPoolDataIdIntern(poolDataId,spaceId);

  mSPoolDataFd=shm_open(
	  poolDataId,
	  O_RDWR|O_CREAT|O_EXCL|O_TRUNC,
	  MSGSPACE_DEFAULT_MODE
	  );
  if (mSPoolDataFd == -1 ) {
	fprintf( stderr, "poolData %s creation failed: %s\n",
		(char*)poolDataId,
		strerror( errno ) );
	return NULL;
  }
  
  /* allocation de la bonne zone mmoire pour le poolData */
  if (ftruncate(mSPoolDataFd, poolNb*sizeof(msgPoolData)) == -1){
	fprintf( stderr, "msgSpace resizing failed: %s\n",
		strerror( errno ) );
	return NULL;
  }

  /* TODO: attacher chacun des msgPoolData :
   * - y crire les informations passes en param
   * - creer les zones mmoires de chacune des pool
   */   
   mSPoolDataAddr = mmap( 0, sizeof( *mSAddr ),
	  PROT_READ | PROT_WRITE,
	  MAP_SHARED, mSFd, 0 );
  if( mSPoolDataAddr == MAP_FAILED ) {
	fprintf( stderr, "mmap failed: %s\n",
		strerror( errno ) );
	return NULL;
  }

  printf( "msgPoolData map addr is 0x%08x\n", (int)mSPoolDataFd );


   
   for (i=0;i<poolNb;i++){
	// creation d'une pool

	// mSAddr->

  }

  
  /* TODO: on ajoute spaceId a la liste des msgSpace connus */

  /* TODO: on cre queueNb files de messages */




  /* on renvoie un pointeur sur le bon spaceId */
  return mSAddr;
}


/*
 * spaceId : blabla
 */

msgSpace * msgSpaceOpen(msgSpaceId spaceId){
  int shmId;
  msgSpaceId nzgId;
  if (msgSpaceIdIntern(nzgId,spaceId) < 0){
	return NULL;
  }
  if ((shmId=shm_open(nzgId,O_RDWR,MSGSPACE_DEFAULT_MODE)) < 0){
	perror("shm_open");
	return NULL;
  }
  return NULL;
}

int msgSpaceDelete(msgSpaceId spaceId){
  fprintf(stderr,"Deleting msgSpace with id : %s\n",spaceId);
  //int shmId;
  msgSpaceId nzgId;
  if (msgSpaceIdIntern(nzgId,spaceId) == -1){
	//TODO: message d'erreur
	return -1;
  }

  if (shm_unlink(nzgId)<0){
	perror("shm_unlink");
	return -1;
  };
  return 0;
}

int msgSpaceIdIntern(msgSpaceId dest,const msgSpaceId src ){
  if (strlen(src)>MSGSPACE_ID_LEN){
	return -1;
  }
  /* sprintf(resNzgId,"/tmp/.nzg-%s",(char *)spaceId); */
#ifdef _NZG_REALFILEID
  sprintf(dest,"/tmp/nzgSpace%s",(char *)src);
#else
  sprintf(dest,"/nzgSpace%s",(char *)src);
#endif
  return 0;
}

int msgPoolDataIdIntern(msgSpaceId dest,const msgSpaceId src ){
  if (strlen(src)>MSGSPACE_ID_LEN){
	return -1;
  }
  /* sprintf(resNzgId,"/tmp/.nzg-%s",(char *)spaceId); */
#ifdef _NZG_REALFILEID
  sprintf(dest,"/tmp/nzgSpacePoolData%s",(char *)src);
#else
  sprintf(dest,"/nzgSpacePoolData%s",(char *)src);
#endif
  return 0;
}
